/************************************************************************ *********
 * Proiectarea cu Microprocesoare
 *********************************************************************************/
 
#include <stdio.h>
#include <avr\io.h>
#include <avr\interrupt.h>


#define F_CPU 16000000
#include <util/delay.h>
#include <stdlib.h>


int val0, val2, val5;
uint8_t channel = 0;
void initBuzz_PWM()
{
	DDRD |= _BV(PD5);
	TCCR1A |= _BV(COM1A0) | _BV(WGM10);
	TCCR1B |= _BV(WGM13) | _BV(CS12); // 64kHz
	OCR1A = 4; // 64 /4 
}

void initLed_PWM()
{
	// Timer 0 - Red
	//DDRB |= _BV(PB3);
	DDRD |= _BV(PD5);
	//TCCR0 |= _BV(WGM01) | _BV(WGM00) | _BV(COM01) | _BV(CS02) | _BV(CS00);
	TCCR1B |= _BV(COM1A1);
	OCR1A = 0xff;
	
	// Timer 1 B - Blue
	//DDRD |= _BV(PD4);
	DDRD |= _BV(PD4);
	TCCR1A |= _BV(COM1B1);
	OCR1B = 0x00;
	
	//// Timer 2 - Green
	//DDRD |= _BV(PD7);
	DDRD |= _BV(PD7);
	TCCR2 = _BV(WGM21) | _BV(WGM20) | _BV(COM21) | _BV(CS22) | _BV(CS20);
	OCR2 = 0xff;
	
}

void color(unsigned char red, unsigned char green, unsigned char blue)
{
	OCR1A = red;
	OCR1B = blue;
	OCR2 = green;
}

void Timer0_init(void)
{
// Initializare timer 1 compare match A pentru a avea un timer la nivel de 1 secunda, 16MHz
	OCR0 = 3;
	TCCR0 = (1<<WGM01) | (1<<CS02) | (1<<CS00);
	TIMSK |= _BV(OCIE0);
}

void ADC_init(void)
{
	ADMUX = (1<<MUX2) | (1<<MUX0);
	// activeaza ADC si intreruperea de conversie. Prescaler de ceas la maximum
	ADCSRA = (1<<ADEN) | (1<<ADIE) | (1<<ADPS2) | (1<<ADPS1) | (1<<ADPS0); //imi trebuie adate?
}

int ADC_get(uint8_t channel)
{	
	//setati canalul de pe care vreti sa faceti citirea
	ADMUX &= 0xE0;
	ADMUX |= channel;
	ADCSRA |= _BV(ADEN)|_BV(ADSC);
	//asteptati sa se termine o conversie
	while(!(ADCSRA & (1<<ADIF)));
	//returnati rezultatul conversiei
	return ADC;	
}

/*SIGNAL(SIG_OUTPUT_COMPARE0)
{	
	// Cod ce se apeleaza 1 data pe secunda
	val = ADC_get(channel); //citim valoarea de la ADC
	printf("\n%4d ", val); //afisam valoarea citita
}*/

unsigned int times = 0;
unsigned int red=0,green=0,blue=1,newred,newgreen,newblue,dred,dblue,dgreen;
	
int main()
{
	//sei();
    /* TODO */
	//DDRD |= ( 1 << PD7);
	srand(1);
	
	initBuzz_PWM();
	initLed_PWM();
	ADC_init();
	Timer0_init();
	
	color(0,0,0);
	unsigned int up = 1;
	unsigned int open = 0, closer = 0, closeb = 0;
	
	while(1)
	{
			
		cli();
		channel = 0;
		val0 = ADC_get(channel);
		channel = 2;
		val2 = ADC_get(channel);
		channel = 5;
		val5 = ADC_get(channel);
		//printf("\n%4d %4d %4d ", val0, val2, val5);
		//sei();
		
		
		if(val0)
			open = 1;
		else
			open = 0;
		if(val2)
			closer = 1;
		else
			closer = 0;
		if(val5)
			closeb = 1;
		else
			closeb = 0;
		
		if (up)
		{
			if (red<255 && closer == 0)
			{
				red+=1;
			} 
			else 
				if (green<255)
				{
					green+=1;
				} 
				else 
					if (blue<255 && closeb == 0) 
					{
						blue+=1;
					} 
					else 
					{
						up=0;
					}
		} 
		else 
		{
			if (blue>0 && closeb == 0) 
			{
				blue-=1;
			} 
			else 
				if (green>0) 
				{
					green-=1;
				} 
				else 
					if (red>0 && closer == 0) 
					{
						red-=1;
					} 
					else 
					{
						up=1;
					}
		}
		
		color(red, green, blue);
		
		_delay_ms(10);
	}
	return 0;
}
